#!/usr/bin/perl

$binary = 'avr.bin';
$config = 'avr.bs';

# Check out my awesome failure message!
# (It sucks to debug code which isn't actually broken, only simply not tested.)

sub failure {
  print LINK "\xFF";
  print STDERR "\n";
  print STDERR "\e[1;5;33m############################################\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m                                        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m  ########    ####    ######  ##        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m  ##        ##    ##    ##    ##        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m  ##        ##    ##    ##    ##        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m  ######    ########    ##    ##        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m  ##        ##    ##    ##    ##        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m  ##        ##    ##    ##    ##        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m  ##        ##    ##  ######  ########  \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m##\e[0;1;31m                                        \e[1;5;33m##\e[0m\n";
  print STDERR "\e[1;5;33m############################################\e[0m\n";
  print STDERR "\n";
  die "\e[1;37m" . $_[0] . "\e[0m\n";
};

$| = 1; # Make writes to STDOUT occur instantly!

open FILE, $ARGV[0];
while ($line = <FILE>) {
  $line =~ s/[\r\n]//g;
  next unless $line =~ /^\*/;
  if (substr($line, 1, 2) eq 'QF') {
    $fuse_count = substr($line, 3) + 0;
  } elsif (substr($line, 1, 1) eq 'F') {
    $fuses = substr($line, 2, 1) x $fuse_count;
  } elsif (substr($line, 1, 1) eq 'L') {
    ($addr, $data) = $line =~ /([0-9]+) ([0-1]+)/;
    substr($fuses, $addr, length($data)) = $data;
  };
};
close FILE;

open_programming_device(); $fudge = 0x06;

magic_number(0);

$temp = read_row(44, 132);

$history = '';
for ($i = 0; $i < 132; $i++) {
  vec($history, $i, 1) = !substr($temp, $i, 1);
};

@history = unpack('C*', $history);

if (@ARGV) {
  if (++$history[15] >= 256) {
    $history[15] = 0;
    $history[16]++;
  };
};
$burn_count = $history[15] + 256 * $history[16];

$history = pack('C*', @history);

$temp = '';
for ($i = 0; $i < 132; $i++) {
  $temp .= 0 + !vec($history, $i, 1);
};
$new_history_bits = $temp;

if (@ARGV) {
  magic_number(61); pv(1); strobe(2); pv(0);
  magic_number(0);
  for ($i = 0; $i < 44; $i++) {
    $data = '';
    for ($j = 0; $j < 132; $j++) {
      $data .= substr($fuses, 44 * $j + $i, 1);
    };
    write_row($i, $data);
    $written[$i] = $data;
  };
  write_row(44, $new_history_bits);
  $written[44] = $new_history_bits;
  write_row(59, ''); # Disable PD pin.
  #write_row(61, ''); # Read protection.
  $data = '';
  for ($i = 0; $i < 10; $i++) {
    for ($j = 0; $j < 2; $j++) {
      $data .= substr($fuses, 5808 + 2 * $i + 1 - $j, 1);
    };
  };
  magic_number(16);
  write_row(-1, $data);
  $written[64] = $data;
};

magic_number(0);
for ($row = 0; $row < 64; $row++) {
  $data = read_row($row, 132);
  $row = substr(' ' . $row, -2);
  $color = '';
  for ($i = 0; $i < 132; $i++) {
    if (substr($data, $i, 1) eq substr($written[$row], $i, 1) or $row > 44) {
      $color .= substr($data, $i, 1);
    } else {
      $color .= "\e[1;31m" . substr($data, $i, 1) . "\e[0m";
    };
  };
  print "$row: $color\n";
};

magic_number(16);
$data = read_row(-1, 20);
$color = '';
for ($i = 0; $i < 20; $i++) {
  if (substr($data, $i, 1) eq substr($written[64], $i, 1)) {
    $color .= substr($data, $i, 1);
  } else {
    $color .= "\e[1;31m" . substr($data, $i, 1) . "\e[0m";
  };
};
print "--: $color\n";

print "Chip has been reprogrammed $burn_count times...\n";

if ($program) {
  print STDERR "\e[1;5;31mDon't forget to disable the erase!\e[0m\n";
};

print LINK "\xFF";
exit;

# The functions that communicate with the programming device:

sub magic_number {
  $magic = $_[0];
  print LINK pack('C', 0x40 | ($_[0] & 0x3F));
};

sub read_row {
  my ($i, $data, $addr, $bits, $text);
  pv(0);
  bit_out($init);
  for ($i = 0; $i < $_[1] + 100; $i++) {
    clock(0);
    clock(1);
  };
  unless ($magic & 16) {
    for ($i = 0; $i < 6; $i++) {
      bit_in();
      clock(0);
      bit_out(($_[0] >> (6 - $i - 1)) & 1);
      clock(1);
    };
  };
  pv(0);
  strobe(0);
  for ($i = 0; $i < $_[1]; $i++) {
    bit_in();
    clock(0);
    bit_out(1); bit_in();
    bit_out(0); bit_in();
    clock(1);
  };
  unless ($magic & 16) {
    read LINK, $addr, 6;
  } else {
    $addr = '';
  };
  read LINK, $data, $_[1] * 3;
  $bits = '';
  for ($i = 0; $i < length($data); $i += 3) {
    $o = substr($data, $i, 3);
    $p = substr($data, $i + 1, 2);
    if ($o eq '000') {
      $bits .= '0';
    } elsif ($o eq '111') {
      $bits .= '1';
    } elsif ($p eq '10') {
      $bits .= "\e[1;32m" . substr($o, 0, 1) . "\e[0m";
    } elsif ($p eq '01') {
      $bits .= "\e[1;31m" . substr($o, 0, 1) . "\e[0m";
    } else {
      #print "exception: $o\n";
      $bits .= "\e[1;33m" . substr($o, 1, 1) . "\e[0m";
    };
  };
  $text = substr(' ' . $_[0], -2);
#  $bits = $data;
#  print "Read $text:  " . $bits . "\n";
  $bits =~ s/\e.*?m//g;
  return $bits;
};

sub write_row {
  my ($i, $data, $addr, $text);
  for ($i = 0; $i < length($_[1]); $i++) {
    bit_in();
    clock(0);
    bit_out(substr($_[1], $i, 1));
    clock(1);
  };
  unless ($magic & 16) {
    for ($i = 0; $i < 6; $i++) {
      bit_in();
      clock(0);
      bit_out(($_[0] >> (6 - $i - 1)) & 1);
      clock(1);
    };
  };
  pv(1);
  strobe(1);
  pv(0);
  #select undef, undef, undef, 0.1;
  unless ($magic & 16) {
    read LINK, $addr, 6;
  } else {
    $addr = '';
  };
  read LINK, $data, length($_[1]);
  $text = substr(' ' . $_[0], -2);
#  print "Write $text: " . $data . "\n";
  return $data;
};

sub clock {
  $fudge &= 0xFD;
  $fudge |= ($_[0] & 1) << 1;
  print LINK pack('C', $fudge);
};

sub strobe {
  my ($i);
  print LINK pack('C', $fudge & 0xFB);
  for ($i = 0; $i < $_[0]; $i++) {
    print LINK pack('C', ($pv << 3) | 0x20);
  };
  print LINK pack('C', $fudge);
  #for ($i = 0; $i < $_[0]; $i++) {
  #  print LINK pack('C', ($pv << 3) | 0x20);
  #};
};

sub pv {
  $fudge &= 0xF7;
  $fudge |= ($_[0] & 1) << 3;
  print LINK pack('C', $fudge);
};

sub bit_out {
  $fudge &= 0xFE;
  $fudge |= $_[0] & 1;
  print LINK pack('C', $fudge);
};

sub bit_in {
  print LINK pack('C', $fudge | 0x10);
};

sub open_programming_device {

  $serial = "Pj-106";

  if ($serial eq '') {
    # If a specific device wasn't specified, let's try to find one...
    @devices = split /\n/, `find /dev/FTDI/JfmTbD/ -type l`;
    #$" = "\n    "; print "Connected AT89S52 programming devices:\n    @devices\n";
    if (@devices < 1) {
      failure
        #________________________________________________________________________________#
        "The programming device was not found.  Peraps it isn't connected.  Perhaps it\n" .
        "is broken.  ...or, perhaps you haven't installed the necessary udev rule which\n" .
        "makes it possible to tell one FT245RL device from another.  If that's the case,\n" .
        "try inserting the following line into '/etc/udev/rules.d/FTDI.rules'\n" .
        "\n" .
        "ATTRS{idVendor}==\"0403\", ATTRS{idProduct}==\"6001\", NAME=\"FTDI/\$attr{serial}\", MODE=\"666\"\n" .
        "\n" .
        "If you create the file, you'll have to restart udev, but if it already exists,\n" .
        "it will probably be sufficient to unplug and replug the programming device.\n";
    } elsif (@devices > 1) {
      $choices = '';
      foreach $device (@devices) {
        $choices .= "  'AVR Programmer' $device\n";
      };
      failure
        #________________________________________________________________________________#
        "You have more than one AT89S52 programmer connected to your computer.  Try one\n" .
        "of the following commands to specify which device you want to use:\n\n$choices\n" .
        "You may also resolve the ambiguity by unplugging all but one of the devices.\n";
    } else {
      $device = $devices[0];
    };
  } else {
    # If something was specified, let's see if it is a usable device...
    if (-c "/dev/FTDI/JfmTbD/$serial") {
      $device = "/dev/FTDI/JfmTbD/$serial";
    } elsif (-c "/dev/FTDI/$serial") {
      $device = "/dev/FTDI/$serial";
    } elsif (-c "/dev/$serial") {
      $device = "/dev/$serial";
    } elsif (-c "$serial") {
      $device = "$serial";
    } else {
      failure("I cannot find a device like '$serial'\n");
    };
  };

  print "Using device '$device'\n";

  print "Opening the programming device...\n";
  `stty raw -echo < '$device'`;
  open LINK, '+<', $device;    # Open the device!
  select LINK; $| = 1; select STDOUT; # Disable Perl's I/O buffer.

  print "Clearing any stale data in any input buffers...\n";
  while ('bitch') {
    $read = $write = $bitch = '';
    vec($read, fileno(LINK), 1) = 1;
    select $read, $write, $whatever, 1/2;
    last unless vec($read, fileno(LINK), 1);
    $result = sysread LINK, $bullshit, 4096;
    if ($result <= 0) {
      failure "OS error reading from programming device: $!\n";
    };
  };

  print "Unlocking the device...\n";
  print LINK pack('H*', 'FFFFFFFFFFFFFFFF' . '8384D4F821D5586B');

};
